## libcotp 1.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(cotp)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(PkgConfig REQUIRED)
find_package(Gcrypt 1.6.0 REQUIRED)
pkg_check_modules(BASEENCODE REQUIRED baseencode>=1.0.5)

include_directories(${GCRYPT_INCLUDE_DIR} ${BASEENCODE_INCLUDE_DIRS})

link_directories(${GCRYPT_LIBRARY_DIRS} ${BASEENCODE_LIBRARY_DIRS})

enable_testing()
add_subdirectory(tests)

# set up versioning.
set(BUILD_MAJOR "1")
set(BUILD_MINOR "2")
set(BUILD_VERSION "2")
set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_VERSION})

set(CMAKE_C_STANDARD 11)

set(COTP_HEADERS src/cotp.h)
set(SOURCE_FILES src/otp.c)

set(CMAKE_C_FLAGS "-Wall -Wextra -O3 -Wno-format-truncation -fstack-protector-strong -fPIC")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")

add_library(cotp SHARED ${SOURCE_FILES})

target_link_libraries(cotp ${GCRYPT_LIBRARIES} ${BASEENCODE_LIBRARIES})

set_target_properties(cotp PROPERTIES VERSION ${BUILD_VERSION} SOVERSION ${BUILD_MAJOR}${BUILD_MINOR})

include(GNUInstallDirs)
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}") # "lib" or "lib64"

install(
  TARGETS cotp
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  COMPONENT library
)

install(
  FILES ${COTP_HEADERS}
  DESTINATION include
)

configure_file("cotp.pc.in" "cotp.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cotp.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== tests/CMakeLists.txt ===

IF(BUILD_TESTING)
    add_executable (test_cotp test_otp.c)

    target_link_libraries (test_cotp -lcotp -lcriterion -lbaseencode -lgcrypt)

    add_test (NAME TestCOTP COMMAND test_cotp)
ENDIF(BUILD_TESTING)

=== debian/changelog ===
libcotp (1.2.2-2) unstable; urgency=medium

  * Source-only upload to allow testing migration.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Mon, 13 Jul 2020 20:22:55 +0000

libcotp (1.2.2-1) unstable; urgency=low

  * Initial release (Closes: #959689)

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Mon, 04 May 2020 01:09:40 +0000

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/$1\/$1\@ANY_VERSION@@ARCHIVE_EXT@@SIGNATURE_EXT@ \
https://github.com/paolostivanin/libcotp/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## libcotp 1.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # set up versioning.
 set(BUILD_MAJOR "1")
 set(BUILD_MINOR "2")
-set(BUILD_VERSION "2")
+set(BUILD_VERSION "3")
 set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_VERSION})
 
 set(CMAKE_C_STANDARD 11)

=== tests/CMakeLists.txt ===

IF(BUILD_TESTING)
    add_executable (test_cotp test_otp.c)

    target_link_libraries (test_cotp -lcotp -lcriterion -lbaseencode -lgcrypt)
    target_link_directories (test_cotp PRIVATE ${PROJECT_BINARY_DIR})
    add_dependencies (test_cotp cotp)

    add_test (NAME TestCOTP COMMAND test_cotp)
ENDIF(BUILD_TESTING)

=== debian/changelog ===
libcotp (1.2.3-1) unstable; urgency=medium

  * New upstream version 1.2.3.
  * debian/patches/use_debhelper_CFLAGS.patch: added 'Forwarded: not-needed'.
  * debian/watch: fixed syntax of pgpsigurlmangle option.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Sun, 27 Sep 2020 05:17:01 +0000

=== debian/control ===
Source: libcotp
Section: libs
Priority: optional
Maintainer: Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libbaseencode-dev,
               libgcrypt20-dev,
               pkg-config
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/paolostivanin/libcotp
Vcs-Browser: https://salsa.debian.org/debian/libcotp
Vcs-Git: https://salsa.debian.org/debian/libcotp.git

Package: libcotp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcotp12 (= ${binary:Version}), ${misc:Depends}
Description: C library that generates TOTP and HOTP (development)
 C library that generates TOTP and HOTP according to RFC-6238.
 .
 This package contains the files needed to compile and link
 programs which use this library.

Package: libcotp12
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library that generates TOTP and HOTP
 C library that generates TOTP and HOTP according to RFC-6238.
 .
 This package contains shared library object.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/v?@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/v$1\/v$1\.tar\.gz\.asc/ \
https://github.com/paolostivanin/libcotp/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## libcotp 1.2.3-1%2B10.0trisquel1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,9 +24,9 @@
 
 set(COTP_HEADERS src/cotp.h)
 set(SOURCE_FILES src/otp.c)
-
-set(CMAKE_C_FLAGS "-Wall -Wextra -O3 -Wno-format-truncation -fstack-protector-strong -fPIC")
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")
+# Removed on Debian in favor of flags set by debhelper
+#set(CMAKE_C_FLAGS "-Wall -Wextra -O3 -Wno-format-truncation -fstack-protector-strong -fPIC")
+#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")
 
 add_library(cotp SHARED ${SOURCE_FILES})

=== debian/changelog ===
libcotp (1.2.3-1+10.0trisquel1) nabia-backports; urgency=medium

  * Backported from Debian stable as a dependency for otpclient

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 19 Sep 2021 18:07:02 +0000

## libcotp 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,16 +17,16 @@
 # set up versioning.
 set(BUILD_MAJOR "1")
 set(BUILD_MINOR "2")
-set(BUILD_VERSION "3")
+set(BUILD_VERSION "4")
 set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_VERSION})
 
 set(CMAKE_C_STANDARD 11)
 
 set(COTP_HEADERS src/cotp.h)
 set(SOURCE_FILES src/otp.c)
-# Removed on Debian in favor of flags set by debhelper
-#set(CMAKE_C_FLAGS "-Wall -Wextra -O3 -Wno-format-truncation -fstack-protector-strong -fPIC")
-#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")
+
+set(CMAKE_C_FLAGS "-Wall -Wextra -O3 -Wno-format-truncation -fstack-protector-strong -fPIC")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")
 
 add_library(cotp SHARED ${SOURCE_FILES})

=== debian/changelog ===
libcotp (1.2.4-1) unstable; urgency=medium

  * New upstream version 1.2.4.
  * Bump Standards-Version to 4.6.0.1.
  * Update upstream and packaging copyright years.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Wed, 29 Dec 2021 14:05:36 +0000

libcotp (1.2.3-2) unstable; urgency=medium

  * Bump Standards-Version to 4.5.1.
  * Update debian/watch.
  * debian/gbp.conf: replace debian/master with debian/latest.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Mon, 16 Aug 2021 15:55:37 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libbaseencode-dev,
                libgcrypt20-dev,
                pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
 Homepage: https://github.com/paolostivanin/libcotp
 Vcs-Browser: https://salsa.debian.org/debian/libcotp

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/v$1\/v$1\.tar\.gz\.asc/ \
https://github.com/paolostivanin/libcotp/releases .*/v@ANY_VERSION@@ARCHIVE_EXT@

## libcotp 1.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,8 @@
 project(cotp)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+
+include(GNUInstallDirs)
 
 find_package(PkgConfig REQUIRED)
 find_package(Gcrypt 1.6.0 REQUIRED)
@@ -17,7 +19,7 @@
 # set up versioning.
 set(BUILD_MAJOR "1")
 set(BUILD_MINOR "2")
-set(BUILD_VERSION "4")
+set(BUILD_VERSION "6")
 set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_VERSION})
 
 set(CMAKE_C_STANDARD 11)
@@ -34,20 +36,33 @@
 
 set_target_properties(cotp PROPERTIES VERSION ${BUILD_VERSION} SOVERSION ${BUILD_MAJOR}${BUILD_MINOR})
 
-include(GNUInstallDirs)
-set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}") # "lib" or "lib64"
+set(COTP_LIB_DIR "${CMAKE_INSTALL_LIBDIR}")
+set(COTP_INC_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
 
 install(
   TARGETS cotp
-  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
-  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
+  ARCHIVE DESTINATION ${COTP_LIB_DIR}
+  LIBRARY DESTINATION ${COTP_LIB_DIR}
   COMPONENT library
 )
 
 install(
   FILES ${COTP_HEADERS}
-  DESTINATION include
+  DESTINATION ${COTP_INC_DIR}
 )
+
+# Allow adding prefix if CMAKE_INSTALL_INCLUDEDIR not absolute.
+if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
+    set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
+else()
+    set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+endif()
+# Allow adding prefix if CMAKE_INSTALL_LIBDIR not absolute.
+if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
+    set(PKGCONFIG_TARGET_LIBS "${CMAKE_INSTALL_LIBDIR}")
+else()
+    set(PKGCONFIG_TARGET_LIBS "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
+endif()
 
 configure_file("cotp.pc.in" "cotp.pc" @ONLY)
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cotp.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== debian/changelog ===
libcotp (1.2.6-1) unstable; urgency=medium

  * New upstream version 1.2.6.
  * Bump Standards-Version to 4.6.1.
  * Update my email address.
  * Update upstream and packaging copyright years.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Mon, 13 Jun 2022 16:15:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: libcotp
 Section: libs
 Priority: optional
-Maintainer: Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>
+Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libbaseencode-dev,
                libgcrypt20-dev,
                pkg-config
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/paolostivanin/libcotp
 Vcs-Browser: https://salsa.debian.org/debian/libcotp

## libcotp 1.2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 find_package(PkgConfig REQUIRED)
 find_package(Gcrypt 1.6.0 REQUIRED)
-pkg_check_modules(BASEENCODE REQUIRED baseencode>=1.0.5)
+pkg_check_modules(BASEENCODE REQUIRED baseencode>=1.0.12)
 
 include_directories(${GCRYPT_INCLUDE_DIR} ${BASEENCODE_INCLUDE_DIRS})
 
@@ -19,7 +19,7 @@
 # set up versioning.
 set(BUILD_MAJOR "1")
 set(BUILD_MINOR "2")
-set(BUILD_VERSION "6")
+set(BUILD_VERSION "8")
 set(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_VERSION})
 
 set(CMAKE_C_STANDARD 11)

=== debian/changelog ===
libcotp (1.2.8-1) unstable; urgency=medium

  * New upstream version 1.2.8. (Closes: #1028305)

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Mon, 16 Jan 2023 21:01:00 +0000

libcotp (1.2.7-1) unstable; urgency=medium

  * New upstream version 1.2.7.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Thu, 05 Jan 2023 15:55:03 +0000

libcotp (1.2.6-2) unstable; urgency=medium

  * Update the search rule in debian/watch.
  * Drop debian/salsa-ci.yml.
  * Update packaging copyright years.
  * Bump Standards-Version to 4.6.2.
  * Update libcotp12 package description.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 03 Jan 2023 14:27:08 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libbaseencode-dev,
                libgcrypt20-dev,
                pkg-config
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/paolostivanin/libcotp
 Vcs-Browser: https://salsa.debian.org/debian/libcotp
@@ -31,4 +31,4 @@
 Description: C library that generates TOTP and HOTP
  C library that generates TOTP and HOTP according to RFC-6238.
  .
- This package contains shared library object.
+ This package contains the shared library object.

## libcotp 2.0.1

=== debian/changelog ===
libcotp (2.0.1-2) unstable; urgency=medium

  * Remove libbaseencode-dev from Build-Depends field.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 27 Jun 2023 19:11:36 +0000

libcotp (2.0.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Wed, 21 Jun 2023 17:18:27 +0000

libcotp (2.0.1-1~exp1) experimental; urgency=medium

  * New upstream version 2.0.1.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Mon, 12 Jun 2023 19:01:26 +0000

libcotp (2.0.0-1) experimental; urgency=medium

  * New upstream version 2.0.0.
  * Drop debian/patches/use_debhelper_CFLAGS.patch.
  * Drop debian/libcotp12.install and debian/libcotp12.symbols.
  * Add debian/libcotp2.install and debian/libcotp2.symbols.
  * SONAME change: libcotp12 -> libcotp2.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 10 Jan 2023 12:36:19 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libbaseencode-dev,
                libgcrypt20-dev,
                pkg-config
 Standards-Version: 4.6.2
@@ -17,14 +16,14 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcotp12 (= ${binary:Version}), ${misc:Depends}
+Depends: libcotp2 (= ${binary:Version}), ${misc:Depends}
 Description: C library that generates TOTP and HOTP (development)
  C library that generates TOTP and HOTP according to RFC-6238.
  .
  This package contains the files needed to compile and link
  programs which use this library.
 
-Package: libcotp12
+Package: libcotp2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

## libcotp 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(cotp VERSION "3.0.0" LANGUAGES "C")

set(CMAKE_C_STANDARD 11)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)

find_package(PkgConfig REQUIRED)

option(BUILD_SHARED_LIBS "Build libcotp as a shared library" ON)
option(BUILD_TESTS "Build base32 and cotp tests" OFF)

set(HMAC_WRAPPER "gcrypt" CACHE STRING "library to use during hmac computation")
if("${HMAC_WRAPPER}" STREQUAL "gcrypt")
    set(HMAC_SOURCE_FILES
            src/utils/whmac_gcrypt.c
    )
    find_package(Gcrypt 1.8.0 REQUIRED)
    set(HMAC_INCLUDE_DIR ${GCRYPT_INCLUDE_DIR})
    set(HMAC_LIBRARY_DIRS ${GCRYPT_LIBRARY_DIRS})
    set(HMAC_LIBRARIES ${GCRYPT_LIBRARIES})
    message("libcotp will use gcrypt for hmac")
elseif("${HMAC_WRAPPER}" STREQUAL "openssl")
    find_package(OpenSSL 3.0.0 REQUIRED)
    set(HMAC_SOURCE_FILES
            src/utils/whmac_openssl.c
    )
    set(HMAC_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
    set(HMAC_LIBRARY_DIRS ${OPENSSL_LIBRARY_DIRS})
    set(HMAC_LIBRARIES ${OPENSSL_LIBRARIES})
    message("libcotp will use openssl for hmac")
else()
    message("libcotp can't use ${HMAC_WRAPPER} for hmac")
endif()

include_directories(${HMAC_INCLUDE_DIR})
link_directories(${HMAC_LIBRARY_DIRS})

if (BUILD_TESTS)
    add_subdirectory(tests)
endif ()

set(COTP_HEADERS
        src/cotp.h
)

set(SOURCE_FILES
        src/otp.c
        ${HMAC_SOURCE_FILES}
        src/utils/base32.c
)

# Set compiler flags for all targets
add_compile_options(-Wall -Wextra -O3 -Wformat=2 -Wmissing-format-attribute -fstack-protector-strong -Wundef -Wmissing-format-attribute
        -fdiagnostics-color=always -Wstrict-prototypes -Wunreachable-code -Wchar-subscripts -Wwrite-strings -Wpointer-arith -Wbad-function-cast
        -Wcast-align -Werror=format-security -Werror=implicit-function-declaration -Wno-sign-compare -Wno-format-nonliteral -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3)

add_library(cotp ${SOURCE_FILES})

target_link_libraries(cotp ${HMAC_LIBRARIES})
target_include_directories(cotp
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/src
        PRIVATE
            ${HMAC_INCLUDE_DIR})
target_compile_options(cotp PRIVATE
        -Wall -Wextra -O3 -Wformat=2 -Wmissing-format-attribute -fstack-protector-strong -Wundef -Wmissing-format-attribute
        -fdiagnostics-color=always -Wstrict-prototypes -Wunreachable-code -Wchar-subscripts -Wwrite-strings -Wpointer-arith -Wbad-function-cast
        -Wcast-align -Werror=format-security -Werror=implicit-function-declaration -Wno-sign-compare -Wno-format-nonliteral -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3)
target_link_directories(cotp PRIVATE
        ${HMACLIBRARY_DIRS})

set_target_properties(cotp PROPERTIES VERSION ${CMAKE_PROJECT_VERSION} SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

set(COTP_LIB_DIR "${CMAKE_INSTALL_LIBDIR}")
set(COTP_INC_DIR "${CMAKE_INSTALL_INCLUDEDIR}")

install(
  TARGETS cotp
  ARCHIVE DESTINATION ${COTP_LIB_DIR}
  LIBRARY DESTINATION ${COTP_LIB_DIR}
  COMPONENT library
)

install(
  FILES ${COTP_HEADERS}
  DESTINATION ${COTP_INC_DIR}
)

# Allow adding prefix if CMAKE_INSTALL_INCLUDEDIR not absolute.
if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
    set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
else()
    set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()
# Allow adding prefix if CMAKE_INSTALL_LIBDIR not absolute.
if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
    set(PKGCONFIG_TARGET_LIBS "${CMAKE_INSTALL_LIBDIR}")
else()
    set(PKGCONFIG_TARGET_LIBS "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()

configure_file("cotp.pc.in" "cotp.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cotp.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== tests/CMakeLists.txt ===
add_executable (test_cotp test_otp.c)
add_executable (test_base32encode test_base32encode.c)
add_executable (test_base32decode test_base32decode.c)

target_link_libraries (test_cotp -lcotp -lcriterion -lgcrypt)
target_link_libraries (test_base32encode -lcotp -lcriterion -lgcrypt)
target_link_libraries (test_base32decode -lcotp -lcriterion -lgcrypt)
target_link_directories (test_cotp PRIVATE ${PROJECT_BINARY_DIR})
target_link_directories (test_base32encode PRIVATE ${PROJECT_BINARY_DIR})
target_link_directories (test_base32decode PRIVATE ${PROJECT_BINARY_DIR})
add_dependencies (test_cotp cotp)
add_dependencies (test_base32encode cotp)
add_dependencies (test_base32decode cotp)

add_test (NAME TestCOTP COMMAND test_cotp)
add_test (NAME TestBase32Encode COMMAND test_base32encode)
add_test (NAME TestBase32Decode COMMAND test_base32decode)

=== debian/changelog ===
libcotp (3.0.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Fri, 02 Aug 2024 12:47:56 +0000

libcotp (3.0.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 19 Dec 2023 17:57:38 +0000

libcotp (3.0.0-1~exp1) experimental; urgency=medium

  * New upstream version 3.0.0.
  * Run 'wrap-and-sort -a'.
  * SONAME change: libcotp2 -> libcotp3.
  * Rename debian/libcotp2.install to debian/libcotp3.install.
  * Rename debian/libcotp2.symbols to debian/libcotp3.symbols.
  * Update debian/libcotp3.symbols.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Wed, 13 Dec 2023 19:04:35 +0000

libcotp (2.1.0-1) unstable; urgency=medium

  * New upstream version 2.1.0.
  * Update debian/libcotp2.symbols.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Thu, 30 Nov 2023 15:30:09 +0000

libcotp (2.0.2-1) unstable; urgency=medium

  * New upstream version 2.0.2.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Thu, 02 Nov 2023 21:13:23 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               cmake,
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                libgcrypt20-dev,
                pkg-config
 Standards-Version: 4.6.2
@@ -16,17 +16,19 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcotp2 (= ${binary:Version}), ${misc:Depends}
+Depends: libcotp3 (= ${binary:Version}),
+         ${misc:Depends}
 Description: C library that generates TOTP and HOTP (development)
  C library that generates TOTP and HOTP according to RFC-6238.
  .
  This package contains the files needed to compile and link
  programs which use this library.
 
-Package: libcotp2
+Package: libcotp3
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: C library that generates TOTP and HOTP
  C library that generates TOTP and HOTP according to RFC-6238.
  .

## libcotp 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(cotp VERSION "3.1.0" LANGUAGES "C")

set(CMAKE_C_STANDARD 11)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)

find_package(PkgConfig)

option(BUILD_SHARED_LIBS "Build libcotp as a shared library" ON)
option(BUILD_TESTS "Build base32 and cotp tests" OFF)
set(HMAC_WRAPPER "gcrypt" CACHE STRING "Choose between gcrypt (default), openssl or mbedtls for HMAC computation")
set_property(CACHE HMAC_WRAPPER PROPERTY STRINGS "gcrypt" "openssl" "mbedtls")

if("${HMAC_WRAPPER}" STREQUAL "gcrypt")
    set(HMAC_SOURCE_FILES
            src/utils/whmac_gcrypt.c
    )
    find_package(Gcrypt 1.8.0 REQUIRED)
    set(HMAC_INCLUDE_DIR ${GCRYPT_INCLUDE_DIR})
    set(HMAC_LIBRARIES ${GCRYPT_LIBRARIES})
    message("libcotp will use gcrypt for hmac")
elseif("${HMAC_WRAPPER}" STREQUAL "openssl")
    find_package(OpenSSL 3.0.0 REQUIRED)
    set(HMAC_SOURCE_FILES
            src/utils/whmac_openssl.c
    )
    set(HMAC_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR})
    set(HMAC_LIBRARIES ${OPENSSL_LIBRARIES})
    message("libcotp will use openssl for hmac")
elseif("${HMAC_WRAPPER}" STREQUAL "mbedtls")
    find_package(MbedTLS REQUIRED)
    set(HMAC_SOURCE_FILES
            src/utils/whmac_mbedtls.c
    )
    set(HMAC_INCLUDE_DIR ${MBEDTLS_INCLUDE_DIRS})
    set(HMAC_LIBRARIES ${MBEDTLS_LIBRARIES})
    message("libcotp will use mbedtls for hmac")
else()
    message("libcotp can't use ${HMAC_WRAPPER} for hmac")
endif()

include_directories(${HMAC_INCLUDE_DIR})

if (BUILD_TESTS)
    add_subdirectory(tests)
endif ()

set(COTP_HEADERS
        src/cotp.h
)

set(SOURCE_FILES
        src/otp.c
        ${HMAC_SOURCE_FILES}
        src/utils/base32.c
)

# Set compiler flags for all targets
if(NOT MSVC)
    add_compile_options(-Wall -Wextra -O3 -Wformat=2 -Wmissing-format-attribute -fstack-protector-strong -Wundef -Wmissing-format-attribute
            -fdiagnostics-color=always -Wstrict-prototypes -Wunreachable-code -Wchar-subscripts -Wwrite-strings -Wpointer-arith -Wbad-function-cast
            -Wcast-align -Werror=format-security -Werror=implicit-function-declaration -Wno-sign-compare -Wno-format-nonliteral -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3)
endif()

add_library(cotp ${SOURCE_FILES})

target_link_libraries(cotp ${HMAC_LIBRARIES})
target_include_directories(cotp
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}/src
        PRIVATE
            ${HMAC_INCLUDE_DIR})
if(NOT MSVC)
    target_compile_options(cotp PRIVATE
            -Wall -Wextra -O3 -Wformat=2 -Wmissing-format-attribute -fstack-protector-strong -Wundef -Wmissing-format-attribute
            -fdiagnostics-color=always -Wstrict-prototypes -Wunreachable-code -Wchar-subscripts -Wwrite-strings -Wpointer-arith -Wbad-function-cast
            -Wcast-align -Werror=format-security -Werror=implicit-function-declaration -Wno-sign-compare -Wno-format-nonliteral -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3)
endif()
target_link_directories(cotp PRIVATE
        ${HMACLIBRARY_DIRS})

set_target_properties(cotp PROPERTIES VERSION ${CMAKE_PROJECT_VERSION} SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

set(COTP_LIB_DIR "${CMAKE_INSTALL_LIBDIR}")
set(COTP_INC_DIR "${CMAKE_INSTALL_INCLUDEDIR}")

install(
  TARGETS cotp
  ARCHIVE DESTINATION ${COTP_LIB_DIR}
  LIBRARY DESTINATION ${COTP_LIB_DIR}
  COMPONENT library
)

install(
  FILES ${COTP_HEADERS}
  DESTINATION ${COTP_INC_DIR}
)

if (PkgConfig_FOUND)
    # Allow adding prefix if CMAKE_INSTALL_INCLUDEDIR not absolute.
    if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
        set(PKGCONFIG_TARGET_INCLUDES "${CMAKE_INSTALL_INCLUDEDIR}")
    else()
        set(PKGCONFIG_TARGET_INCLUDES "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
    endif()
    # Allow adding prefix if CMAKE_INSTALL_LIBDIR not absolute.
    if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
        set(PKGCONFIG_TARGET_LIBS "${CMAKE_INSTALL_LIBDIR}")
    else()
        set(PKGCONFIG_TARGET_LIBS "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
    endif()

    configure_file("cotp.pc.in" "cotp.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cotp.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)
endif()

=== debian/changelog ===
libcotp (3.1.0-1) unstable; urgency=medium

  * New upstream version 3.1.0.
  * Bump Standards-Version to 4.7.0.
  * Change from pkg-config to pkgconf in the Build-Depends field.
  * Add new upstream rights and update upstream and packaging copyright years.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 08 Oct 2024 15:32:45 +0000

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libgcrypt20-dev,
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/paolostivanin/libcotp
 Vcs-Browser: https://salsa.debian.org/debian/libcotp

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/v$1\/v$1\.tar\.gz\.asc/ \
https://github.com/paolostivanin/libcotp/tags .*/v@ANY_VERSION@@ARCHIVE_EXT@

## libcotp 3.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.16)
-project(cotp VERSION "3.1.0" LANGUAGES "C")
+project(cotp VERSION "3.1.1" LANGUAGES "C")
 
 set(CMAKE_C_STANDARD 11)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,14 @@
 add_executable (test_base32encode test_base32encode.c)
 add_executable (test_base32decode test_base32decode.c)
 
-target_link_libraries (test_cotp -lcotp -lcriterion -lgcrypt)
-target_link_libraries (test_base32encode -lcotp -lcriterion -lgcrypt)
-target_link_libraries (test_base32decode -lcotp -lcriterion -lgcrypt)
+if("${HMAC_WRAPPER}" STREQUAL "gcrypt")
+    set(HMAC_LIBRARIES ${GCRYPT_LIBRARIES})
+elseif("${HMAC_WRAPPER}" STREQUAL "openssl")
+    set(HMAC_LIBRARIES ${OPENSSL_LIBRARIES})
+endif()
+target_link_libraries (test_cotp -lcotp -lcriterion ${HMAC_LIBRARIES})
+target_link_libraries (test_base32encode -lcotp -lcriterion ${HMAC_LIBRARIES})
+target_link_libraries (test_base32decode -lcotp -lcriterion ${HMAC_LIBRARIES})
 target_link_directories (test_cotp PRIVATE ${PROJECT_BINARY_DIR})
 target_link_directories (test_base32encode PRIVATE ${PROJECT_BINARY_DIR})
 target_link_directories (test_base32decode PRIVATE ${PROJECT_BINARY_DIR})

=== debian/changelog ===
libcotp (3.1.1-1) unstable; urgency=medium

  * New upstream version 3.1.1.
  * Bump Standards-Version to 4.7.2.
  * Remove "Rules-Requires-Root: no" (default since dpkg 1.22.13).
  * Update upstream and packaging copyright years.
  * Update debian/watch from the old "version=4" syntax
    to the new "Version: 5" RFC-822 style format.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Tue, 30 Sep 2025 13:57:11 +0000

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
                debhelper-compat (= 13),
                libgcrypt20-dev,
                pkgconf
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://github.com/paolostivanin/libcotp
 Vcs-Browser: https://salsa.debian.org/debian/libcotp
 Vcs-Git: https://salsa.debian.org/debian/libcotp.git
